"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var Pagination_1 = __importDefault(require("react-bootstrap/Pagination"));
var calcLinksToDisplay_1 = __importDefault(require("./calcLinksToDisplay"));
var PaginationItemWrapper_1 = __importDefault(require("./PaginationItemWrapper"));
var ELLIPSIS_MARK = -1;
var PaginationWrapper = function (_a) {
    var _b = _a.atBeginEnd, atBeginEnd = _b === void 0 ? 2 : _b, _c = _a.aroundCurrent, aroundCurrent = _c === void 0 ? 1 : _c, disabled = _a.disabled, _d = _a.name, name = _d === void 0 ? 'page' : _d, onChange = _a.onChange, readOnly = _a.readOnly, _e = _a.showFirstLast, showFirstLast = _e === void 0 ? true : _e, _f = _a.showPrevNext, showPrevNext = _f === void 0 ? true : _f, totalPages = _a.totalPages, value = _a.value, etc = __rest(_a, ["atBeginEnd", "aroundCurrent", "disabled", "name", "onChange", "readOnly", "showFirstLast", "showPrevNext", "totalPages", "value"]);
    var handleClickF = react_1.useCallback(function (page) { return function () {
        if (!onChange) {
            console.warn('onChange() method is not set for PaginationWrapper ("'
                + name + '"), but page change occurs');
            return;
        }
        return onChange({ target: { name: name, value: page } });
    }; }, [name, onChange]);
    var handleFirst = react_1.useCallback(function () { return handleClickF(0); }, [handleClickF]);
    var handlePrev = react_1.useCallback(function () { return handleClickF(value - 1); }, [handleClickF, value]);
    var handlePage = react_1.useCallback(function (page) { return handleClickF(page); }, [handleClickF]);
    var handleNext = react_1.useCallback(function () { return handleClickF(value + 1); }, [handleClickF, value]);
    var handleLast = react_1.useCallback(function () { return totalPages !== undefined ? handleClickF(totalPages - 1) : undefined; }, [handleClickF, totalPages]);
    var linksToDisplay = calcLinksToDisplay_1.default(totalPages, value, atBeginEnd, aroundCurrent, ELLIPSIS_MARK);
    var allDisabled = disabled || readOnly;
    return react_1.default.createElement(Pagination_1.default, __assign({}, etc),
        showFirstLast && (value <= 0 || allDisabled
            ? react_1.default.createElement(Pagination_1.default.First, { disabled: true, key: "-2" })
            : react_1.default.createElement(Pagination_1.default.First, { key: "-2", onClick: handleFirst })),
        showPrevNext && (value <= 0 || allDisabled
            ? react_1.default.createElement(Pagination_1.default.Prev, { disabled: true, key: "-1" })
            : react_1.default.createElement(Pagination_1.default.Prev, { key: "-1", onClick: handlePrev })),
        linksToDisplay.map(function (p, index) {
            return p === value
                ? react_1.default.createElement(Pagination_1.default.Item, { active: true, key: p }, p + 1)
                : p === ELLIPSIS_MARK
                    ? react_1.default.createElement(Pagination_1.default.Ellipsis, { disabled: true, key: "_" + index })
                    : allDisabled
                        ? react_1.default.createElement(Pagination_1.default.Item, { disabled: true, key: p }, p + 1)
                        : react_1.default.createElement(PaginationItemWrapper_1.default, { onClick: handlePage, page: p });
        }),
        showPrevNext && (totalPages !== undefined && value >= totalPages - 1 || allDisabled
            ? react_1.default.createElement(Pagination_1.default.Next, { disabled: true, key: "+1" })
            : react_1.default.createElement(Pagination_1.default.Next, { key: "+1", onClick: handleNext })),
        totalPages !== undefined && showFirstLast && (value >= totalPages - 1 || allDisabled
            ? react_1.default.createElement(Pagination_1.default.Last, { disabled: true, key: "+2" })
            : react_1.default.createElement(Pagination_1.default.Last, { key: "+2", onClick: handleLast })));
};
exports.default = react_1.default.memo(PaginationWrapper);
